(function($)
{

	var target;
	var currstr = '';
	var showing = false;

	var valsettings

	$.fn.calcField = function(v)
	{
		valsettings = v;
//		this.fadeIn('normal', function(){// the this keyword is a DOM element});
		initCalc();
		this.attr('readonly',true);
		this.on("vclick",showCalc);
//		this.blur(hideCalc);
		this.addClass('calcinput');
//		alert('init!');
	};

	function showCalc(e)
	{
		e.preventDefault();
		e.stopImmediatePropagation();
		$('.selectedfield').removeClass('selectedfield');
		console.log("showcalc()");
		currstr = '';
		target = $(this);
		target.addClass('selectedfield');
		$("#calc").css('width',$('body').width());
		$("#calc input").val(target.val());
		$("#calc").show();
		
		$(document).on
		(
			"vclick",
			function(e)
			{
				if(!showing)
				{
					return;
				}
//				console.log(e.target);
				var container = $("#calc");
				if(container.has(e.target).length === 0)
				{
					console.log(showing+' 0');
					container.hide();
					showing = false;
					target.removeClass('selectedfield');
				}
			}
		);

		$(document).on("backbutton",backHandler);

		showing = true;

	}

	function backHandler(e)
	{
		console.log("backbutton");
//		alert("backbutton");
		if(showing)
		{
//			alert("calc is showing...hiding...");
			e.preventDefault();
			doHideCalc();
		}
		$(document).off("backbutton");
	}

	function doHideCalc()
	{
		$("#calc").hide();
		showing = false;
		target.removeClass('selectedfield');
	}

	function hideCalc()
	{
		console.log($(document.activeElement));
		target.removeClass('selectedfield');
	}

	function initCalc()
	{
		var cstr = '<div class="calc" id="calc">';
		cstr += '<table cellspacing="0" cellpadding="0">';
		cstr += '<tr><td colspan="4"><input type="text" readonly="true"></td></tr>';
		cstr += '<tr>';
		for(var i=7;i<=9;i++){cstr += '<td class="button_'+i+'">'+i+'</td>';}
		cstr += '</tr>';
		cstr += '<tr>';
		for(var i=4;i<=6;i++){cstr += '<td class="button_'+i+'">'+i+'</td>';}
		cstr += '</tr>';
		cstr += '<tr>';
		for(var i=1;i<=3;i++){cstr += '<td class="button_'+i+'">'+i+'</td>';}
		cstr += '</tr>';
		cstr += '<tr>';
		cstr += '<td class="button_dot">.</td>';
		cstr += '<td class="button_0">0</td>';
		cstr += '<td class="button_c">C</td>';
		cstr += '</tr>';

		cstr += '</table>';
		cstr += '</div>';
		$('body').append(cstr);
		initKeys();
	}

	function keyHandler(k)
	{
//		alert('click: '+k);
		var v = valsettings[target.attr('id')];
		var pstr = currstr;
//		console.log(valsettings[v].max);
		switch(k)
		{
			case '9':		currstr+=k;break;
			case '8':		currstr+=k;break;
			case '7':		currstr+=k;break;
			case '6':		currstr+=k;break;
			case '5':		currstr+=k;break;
			case '4':		currstr+=k;break;
			case '3':		currstr+=k;break;
			case '2':		currstr+=k;break;
			case '1':		currstr+=k;break;

			case '0':		(currstr==''||currstr=='0'?currstr='0':currstr+=k);break;
			case 'c':		currstr='';break;
			case '.':		if(currstr=='')
						{
							currstr='0.';
						}
						else if(!currstr.match(/\./))
						{
							currstr+='.';
						}
						break;
			default:		break;
		}

		if(currstr > v.max)
		{
			currstr = pstr;
		}

		$("#calc input").val(currstr);
		target.val(currstr);
		target.change();
	}

	function initKeys()
	{
		$(".button_7").on("vclick",function(){keyHandler('7')});
		$(".button_8").on("vclick",function(){keyHandler('8')});
		$(".button_9").on("vclick",function(){keyHandler('9')});

		$(".button_4").on("vclick",function(){keyHandler('4')});
		$(".button_5").on("vclick",function(){keyHandler('5')});
		$(".button_6").on("vclick",function(){keyHandler('6')});

		$(".button_1").on("vclick",function(){keyHandler('1')});
		$(".button_2").on("vclick",function(){keyHandler('2')});
		$(".button_3").on("vclick",function(){keyHandler('3')});

		$(".button_dot").on("vclick",function(){keyHandler('.')});
		$(".button_0").on("vclick",function(){keyHandler('0')});
		$(".button_c").on("vclick",function(){keyHandler('c')});
	}

})(jQuery);
